Lucene++ - a full-featured, c++ search engine
API Documentation

- Main Page
- Related Pages
- Namespaces
- Data Structures
- Files

- Data Structures
- Class Hierarchy
- Data Fields

Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes
Lucene::TermRangeQuery Class Reference

A Query that matches documents within an range of terms. More...

`#include <TermRangeQuery.h>`

Inheritance diagram for Lucene::TermRangeQuery:

## Public Member Functions

| TermRangeQuery (const String &fieldName, StringValue lowerTerm, StringValue upperTerm, bool includeLower, bool includeUpper, CollatorPtr collator=CollatorPtr())
| Constructs a query selecting all terms greater/equal than lowerTerm but less/equal than upperTerm. More...
virtual | ~TermRangeQuery ()
virtual String | getClassName ()
boost::shared_ptr< TermRangeQuery > | shared_from_this ()
String | getField ()
| Returns the field name for this query. More...
String | getLowerTerm ()
| Returns the lower value of this range query. More...
String | getUpperTerm ()
| Returns the upper value of this range query. More...
bool | includesLower ()
| Returns true if the lower endpoint is inclusive. More...
bool | includesUpper ()
| Returns true if the upper endpoint is inclusive. More...
CollatorPtr | getCollator ()
| Returns the collator used to determine range inclusion, if any. More...
virtual LuceneObjectPtr | clone (const LuceneObjectPtr &other=LuceneObjectPtr())
| Returns a clone of this query. More...
virtual String | toString (const String &field)
| Prints a query to a string, with field assumed to be the default field and omitted. More...
virtual int32_t | hashCode ()
| Return hash code for this object. More...
virtual bool | equals (const LuceneObjectPtr &other)
| Return whether two objects are equal. More...
Public Member Functions inherited from Lucene::MultiTermQuery
| MultiTermQuery ()
virtual | ~MultiTermQuery ()
boost::shared_ptr< MultiTermQuery > | shared_from_this ()
int32_t | getTotalNumberOfTerms ()
| Return the number of unique terms visited during execution of the query. If there are many of them, you may consider using another query type or optimize your total term count in index. More...
void | clearTotalNumberOfTerms ()
| Resets the counting of unique terms. Do this before executing the query/filter. More...
virtual QueryPtr | rewrite (const IndexReaderPtr &reader)
| Called to re-write queries into primitive queries. For example, a PrefixQuery will be rewritten into a BooleanQuery that consists of TermQuerys. More...
virtual RewriteMethodPtr | getRewriteMethod ()
virtual void | setRewriteMethod (const RewriteMethodPtr &method)
| Sets the rewrite method to be used when executing the query. You can use one of the four core methods, or implement your own subclass of RewriteMethod. More...
Public Member Functions inherited from Lucene::Query
| Query ()
virtual | ~Query ()
boost::shared_ptr< Query > | shared_from_this ()
virtual void | setBoost (double b)
| Sets the boost for this query clause to b. Documents matching this clause will (in addition to the normal weightings) have their score multiplied by b. More...
virtual double | getBoost ()
| Gets the boost for this clause. Documents matching this clause will (in addition to the normal weightings) have their score multiplied by b. The boost is 1.0 by default. More...
virtual String | toString ()
| Prints a query to a string. More...
virtual WeightPtr | createWeight (const SearcherPtr &searcher)
| Constructs an appropriate Weight implementation for this query. Only implemented by primitive queries, which re-write to themselves. More...
virtual WeightPtr | weight (const SearcherPtr &searcher)
| Constructs and initializes a Weight for a top-level query. More...
virtual QueryPtr | combine (Collection< QueryPtr > queries)
| Called when re-writing queries under MultiSearcher. More...
virtual void | extractTerms (SetTerm terms)
| Adds all terms occurring in this query to the terms set. Only works if this query is in its rewritten form. More...
virtual SimilarityPtr | getSimilarity (const SearcherPtr &searcher)
| Returns the Similarity implementation to be used for this query. Subclasses may override this method to specify their own Similarity implementation, perhaps one that delegates through that of the Searcher. By default the Searcher's Similarity implementation is returned. More...
String | boostString ()
| Return given boost value as a string. More...
Public Member Functions inherited from Lucene::LuceneObject
virtual | ~LuceneObject ()
virtual void | initialize ()
| Called directly after instantiation to create objects that depend on this object being fully constructed. More...
virtual int32_t | compareTo (const LuceneObjectPtr &other)
| Compare two objects. More...
Public Member Functions inherited from Lucene::LuceneSync
virtual | ~LuceneSync ()
virtual SynchronizePtr | getSync ()
| Return this object synchronize lock. More...
virtual LuceneSignalPtr | getSignal ()
| Return this object signal. More...
virtual void | lock (int32_t timeout=0)
| Lock this object using an optional timeout. More...
virtual void | unlock ()
| Unlock this object. More...
virtual bool | holdsLock ()
| Returns true if this object is currently locked by current thread. More...
virtual void | wait (int32_t timeout=0)
| Wait for signal using an optional timeout. More...
virtual void | notifyAll ()
| Notify all threads waiting for signal. More...

## Static Public Member Functions

static String | _getClassName ()
Static Public Member Functions inherited from Lucene::MultiTermQuery
static String | _getClassName ()
static RewriteMethodPtr | CONSTANT_SCORE_FILTER_REWRITE ()
| A rewrite method that first creates a private Filter, by visiting each term in sequence and marking all docs for that term. Matching documents are assigned a constant score equal to the query's boost. More...
static RewriteMethodPtr | SCORING_BOOLEAN_QUERY_REWRITE ()
| A rewrite method that first translates each term into BooleanClause.Occur#SHOULD clause in a BooleanQuery, and keeps the scores as computed by the query. Note that typically such scores are meaningless to the user, and require non-trivial CPU to compute, so it's almost always better to use CONSTANT_SCORE_AUTO_REWRITE_DEFAULT instead. More...
static RewriteMethodPtr | CONSTANT_SCORE_BOOLEAN_QUERY_REWRITE ()
| Like SCORING_BOOLEAN_QUERY_REWRITE except scores are not computed. Instead, each matching document receives a constant score equal to the query's boost. More...
static RewriteMethodPtr | CONSTANT_SCORE_AUTO_REWRITE_DEFAULT ()
| Read-only default instance of ConstantScoreAutoRewrite, with ConstantScoreAutoRewrite#setTermCountCutoff set to ConstantScoreAutoRewrite#DEFAULT_TERM_COUNT_CUTOFF and ConstantScoreAutoRewrite#setDocCountPercent set to ConstantScoreAutoRewrite#DEFAULT_DOC_COUNT_PERCENT. Note that you cannot alter the configuration of this instance; you'll need to create a private instance instead. More...
Static Public Member Functions inherited from Lucene::Query
static String | _getClassName ()
static QueryPtr | mergeBooleanQueries (Collection< BooleanQueryPtr > queries)
| Merges the clauses of a set of BooleanQuery's into a single BooleanQuery. More...

## Protected Member Functions

virtual FilteredTermEnumPtr | getEnum (const IndexReaderPtr &reader)
| Construct the enumeration to be used, expanding the pattern term. More...
Protected Member Functions inherited from Lucene::MultiTermQuery
void | incTotalNumberOfTerms (int32_t inc)
Protected Member Functions inherited from Lucene::LuceneObject
| LuceneObject ()

## Protected Attributes

StringValue | lowerTerm
StringValue | upperTerm
CollatorPtr | collator
String | field
bool | includeLower
bool | includeUpper
Protected Attributes inherited from Lucene::MultiTermQuery
RewriteMethodPtr | rewriteMethod
int32_t | numberOfTerms
Protected Attributes inherited from Lucene::Query
double | boost
Protected Attributes inherited from Lucene::LuceneSync
SynchronizePtr | objectLock
LuceneSignalPtr | objectSignal

## Detailed Description

A Query that matches documents within an range of terms.

This query matches the documents looking for terms that fall into the supplied range according to String#compare(String), unless a Collator is provided. It is not intended for numerical ranges; use NumericRangeQuery instead.

This query uses the MultiTermQuery#CONSTANT_SCORE_AUTO_REWRITE_DEFAULT rewrite method.

## Constructor & Destructor Documentation

Lucene::TermRangeQuery::TermRangeQuery | ( | const String & | fieldName,
|  | StringValue | lowerTerm,
|  | StringValue | upperTerm,
|  | bool | includeLower,
|  | bool | includeUpper,
|  | CollatorPtr | collator = `CollatorPtr()`
| ) |  |

Constructs a query selecting all terms greater/equal than lowerTerm but less/equal than upperTerm.

If an endpoint is null, it is said to be "open". Either or both endpoints may be open. Open endpoints may not be exclusive (you can't select all but the first or last term without explicitly specifying the term to exclude.)

If collator is not null, it will be used to decide whether index terms are within the given range, rather than using the Unicode code point order in which index terms are stored.

Warning: Using this constructor and supplying a non-null value in the collator parameter will cause every single index Term in the Field referenced by lowerTerm and/or upperTerm to be examined. Depending on the number of index Terms in this Field, the operation could be very slow.

Parameters

  lowerTerm | The Term text at the lower end of the range
  upperTerm | The Term text at the upper end of the range
  includeLower | If true, the lowerTerm is included in the range.
  includeUpper | If true, the upperTerm is included in the range.
  collator | The collator to use to collate index Terms, to determine their membership in the range bounded by lowerTerm and upperTerm.

virtual Lucene::TermRangeQuery::~TermRangeQuery | ( |  | ) |

virtual

## Member Function Documentation

static String Lucene::TermRangeQuery::_getClassName | ( |  | ) |

inline static

virtual LuceneObjectPtr Lucene::TermRangeQuery::clone | ( | const LuceneObjectPtr & | other = `LuceneObjectPtr()` | ) |

virtual

Returns a clone of this query.

Reimplemented from Lucene::MultiTermQuery.

virtual bool Lucene::TermRangeQuery::equals | ( | const LuceneObjectPtr & | other | ) |

virtual

Return whether two objects are equal.

Reimplemented from Lucene::MultiTermQuery.

virtual String Lucene::TermRangeQuery::getClassName | ( |  | ) |

inline virtual

Reimplemented from Lucene::MultiTermQuery.

CollatorPtr Lucene::TermRangeQuery::getCollator | ( |  | ) |

Returns the collator used to determine range inclusion, if any.

virtual FilteredTermEnumPtr Lucene::TermRangeQuery::getEnum | ( | const IndexReaderPtr & | reader | ) |

protected virtual

Construct the enumeration to be used, expanding the pattern term.

Implements Lucene::MultiTermQuery.

String Lucene::TermRangeQuery::getField | ( |  | ) |

Returns the field name for this query.

String Lucene::TermRangeQuery::getLowerTerm | ( |  | ) |

Returns the lower value of this range query.

String Lucene::TermRangeQuery::getUpperTerm | ( |  | ) |

Returns the upper value of this range query.

virtual int32_t Lucene::TermRangeQuery::hashCode | ( |  | ) |

virtual

Return hash code for this object.

Reimplemented from Lucene::MultiTermQuery.

bool Lucene::TermRangeQuery::includesLower | ( |  | ) |

Returns true if the lower endpoint is inclusive.

bool Lucene::TermRangeQuery::includesUpper | ( |  | ) |

Returns true if the upper endpoint is inclusive.

boost::shared_ptr< TermRangeQuery > Lucene::TermRangeQuery::shared_from_this | ( |  | ) |

inline

virtual String Lucene::TermRangeQuery::toString | ( | const String & | field | ) |

virtual

Prints a query to a string, with field assumed to be the default field and omitted.

The representation used is one that is supposed to be readable by QueryParser. However, there are the following limitations:

If the query was created by the parser, the printed representation may not be exactly what was parsed. For example, characters that need to be escaped will be represented without the required backslash.

Some of the more complicated queries (eg. span queries) don't have a representation that can be parsed by QueryParser.

Reimplemented from Lucene::Query.

## Field Documentation

CollatorPtr Lucene::TermRangeQuery::collator

protected

String Lucene::TermRangeQuery::field

protected

bool Lucene::TermRangeQuery::includeLower

protected

bool Lucene::TermRangeQuery::includeUpper

protected

StringValue Lucene::TermRangeQuery::lowerTerm

protected

StringValue Lucene::TermRangeQuery::upperTerm

protected

The documentation for this class was generated from the following file:

- TermRangeQuery.h

clucene.sourceforge.net